'use strict';

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = _postcss2.default.plugin('postcss-selector-namespace', function () {
  var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var _options$namespace = options.namespace;
  var namespace = _options$namespace === undefined ? '.self' : _options$namespace;
  var _options$selfSelector = options.selfSelector;
  var selfSelector = _options$selfSelector === undefined ? /:--namespace/ : _options$selfSelector;

  selfSelector = regexpToGlobalRegexp(options.selfSelector);

  return function (css, result) {
    css.walkRules(function (rule) {
      rule.selectors = rule.selectors.map(function (selector) {
        if (selfSelector.test(selector)) {
          return selector.replace(selfSelector, namespace);
        }

        return namespace + ' ' + selector;
      });
    });
  };
});

/**
 * Newer javascript engines allow setting flags when passing existing regexp
 * to the RegExp constructor, until then, we extract the regexp source and
 * build a new object.
 */
function regexpToGlobalRegexp(regexp) {
  var source = regexp instanceof RegExp ? regexp.source : regexp;
  return new RegExp(source, 'g');
}